local _,stash = ...
local L = stash.localization
local C = stash.constants
local settings = stash.settings
stash.moneyPanel = stash.frame.moneyPanel

function stash.moneyPanel:Setup()
    self.Top.Title:SetText(L["Gold across all realms/factions"])
    self.Bottom.BackButton.Text:SetText(OKAY)

	local scrollFrame = self.List
	scrollFrame.template = "StashMoneyListButtonTemplate"
	scrollFrame.callback = self.FillListButton
    -- scrollFrame.list is defined in the update

    stash.tracking:SetCallback("money",function() self:Update() end)    
end

-- updates the money panel immediately without a delay; except in rare cases, updates
-- should go through stash.moneyPanel:Update() to throttle calls to this function
function stash.moneyPanel:UpdateNow()
    if not self:IsVisible() then
        return
    end
    self.Bottom:SetPoint("BOTTOMRIGHT",settings.LockWindow and 0 or -24, 0)
    self.List.list = stash.info:FindMoney()
    tinsert(self.List.list,1,{nil,nil,L["Total"],"money",stash.info:CountAllMoney(true)})
    self.List:Update()
end

-- deferred update of the panel
function stash.moneyPanel:Update()
    stash.timer:Start(C.UI_UPDATE_DELAY,self.UpdateNow,self)
end

-- when panel shown do an immediate update
function stash.moneyPanel:OnShow()
    self:UpdateNow()
end

-- callback to fill in a line in the money list
function stash.moneyPanel:FillListButton(info)
    local color = not info[C.FOUND_REALM] and C.HEX_GOLD or info[C.FOUND_PLAYER]:match(" ") and C.HEX_GREEN or C.FACTION_COLORS[info[C.FOUND_FACTION]] or C.HEX_NEUTRAL
    self.Name:SetText(format("%s%s",color,info[C.FOUND_PLAYER]))
    self.Stripe:SetShown(self.index%2==0)
    self.Money:SetAmount(info[C.FOUND_COUNT])
end

function stash.moneyPanel.Top.SettingsToggle:OnClick()
    stash.moneyPanel:Hide()
    stash.settingsPanel:Show()
end